package de.mach.tools.neodesigner.core.datamodel;

/**
 * Represnetiert einen Fremdschlssel im Relationalen Datenbankmodel.
 *
 * @author Chris Deter
 *
 */
public interface ForeignKey extends Index {

  /**
   * Gibt die Referenztablle zurck.
   *
   * @return Referenz Tabelle (Tabelle die mit dieser Tabelle verknpft ist)
   */
  public Table getRefTable();

  /**
   * setzt die Referenz Tabelle.
   *
   * @param refTable
   *          die Referenz Tabelle
   */
  public void setRefTable(Table refTable);

  /**
   * gibt den Index zu diesem FK zurck.
   *
   * @return Index des Fremdschlssels
   */
  public Index getIndex();

  /**
   * setzt den Index des Fremdschlssels
   *
   * @param i
   *          der Index des Fremdschlssels.
   */
  public void setIndex(Index i);
}
